import * as React from "react";
import * as T from "../Table";
import { Column, ColumnProps } from "./Column";
import * as P from "../Pagination";
export declare type Data = {
    key: string;
    [key: string]: string;
};
declare type RowKey = {
    rowKey?: string;
};
export declare type SheetProps = {
    columns: React.ReactElement<ColumnProps, typeof Column>[];
    data: Data[];
    offset?: number;
    pageSize?: number;
    count?: number;
    activeRow?: string;
    children?: React.ReactNode;
    Table?: React.ElementType<T.TableProps>;
    THead?: React.ElementType<T.THeadProps>;
    TBody?: React.ElementType<T.TBodyProps>;
    TFoot?: React.ElementType<T.TFootProps>;
    TR?: React.ElementType<T.TRProps & RowKey>;
    renderTRHead?: (props: T.TRHeadProps, data: Data) => React.ReactNode;
    TRBody?: React.ElementType<T.TRBodyProps & RowKey>;
    TD?: React.ElementType<T.TDProps>;
    TH?: React.ElementType<T.THProps>;
    Pagination?: React.ElementType<P.PaginationProps>;
};
export declare const Sheet: React.FC<SheetProps>;
export {};
//# sourceMappingURL=Sheet.d.ts.map