"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sheet = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var T = __importStar(require("../Table"));
var Column_1 = require("./Column");
var P = __importStar(require("../Pagination"));
function isHTMLElement(node) {
    return node instanceof HTMLElement;
}
var CHECK_LINE_BREAK_TIMEOUT = 50;
function calculatePages(count, pageSize) {
    if (count === undefined || pageSize === undefined) {
        return 1;
    }
    return Math.ceil(count / pageSize);
}
function calculateActivePage(offset, pageSize) {
    if (pageSize === undefined) {
        return 1;
    }
    return Math.floor(offset / pageSize) + 1;
}
function defaultRenderTRHead(props) {
    return jsx_runtime_1.jsx(T.TRHead, __assign({}, props), void 0);
}
var Sheet = function (_a) {
    var columns = _a.columns, data = _a.data, activeRow = _a.activeRow, children = _a.children, pageSize = _a.pageSize, _b = _a.offset, offset = _b === void 0 ? 0 : _b, count = _a.count, _c = _a.Table, Table = _c === void 0 ? T.Table : _c, _d = _a.THead, THead = _d === void 0 ? T.THead : _d, _e = _a.TBody, TBody = _e === void 0 ? T.TBody : _e, _f = _a.TFoot, TFoot = _f === void 0 ? T.TFoot : _f, _g = _a.TR, TR = _g === void 0 ? T.TR : _g, _h = _a.renderTRHead, renderTRHead = _h === void 0 ? defaultRenderTRHead : _h, _j = _a.TRBody, TRBody = _j === void 0 ? T.TRBody : _j, _k = _a.TD, TD = _k === void 0 ? T.TD : _k, _l = _a.TH, TH = _l === void 0 ? T.TH : _l, _m = _a.Pagination, Pagination = _m === void 0 ? P.Pagination : _m;
    var headRowRef = React.useRef(null);
    var _o = React.useState(false), lineBreak = _o[0], setLineBreak = _o[1];
    React.useEffect(function () {
        function checkLineBreak() {
            if (headRowRef.current === null) {
                return;
            }
            var cells = Array.from(headRowRef.current.childNodes)
                .slice(1)
                .filter(isHTMLElement);
            setLineBreak(cells.some(function (cell) { return cell.offsetLeft === 0; }));
        }
        var timeout;
        function checkLineBreakDebounced() {
            window.clearTimeout(timeout);
            timeout = window.setTimeout(checkLineBreak, CHECK_LINE_BREAK_TIMEOUT);
        }
        window.addEventListener("resize", checkLineBreakDebounced, {
            passive: true,
        });
        checkLineBreak();
        return function () {
            window.removeEventListener("resize", checkLineBreakDebounced);
        };
    }, [headRowRef.current]);
    var ths = columns.map(function (column, index) { return Column_1.thFromColumn(TH, column); });
    var trs = data.map(function (record) {
        var isActive = !!activeRow && record.key === activeRow;
        return (jsx_runtime_1.jsxs(TR, __assign({ rowKey: record.key }, { children: [renderTRHead({
                    primary: isActive,
                    children: columns.map(function (column) {
                        return Column_1.tdFromColumn(TD, column, record[column.props.name]);
                    }),
                }, record),
                isActive && jsx_runtime_1.jsx(TRBody, { children: children }, void 0)] }), record.key));
    });
    var pages = calculatePages(count, pageSize);
    var activePage = calculateActivePage(offset, pageSize);
    return (jsx_runtime_1.jsxs(Table, __assign({ showLabels: lineBreak }, { children: [jsx_runtime_1.jsx(THead, { children: jsx_runtime_1.jsx(TR, { children: jsx_runtime_1.jsx(T.TRHead, __assign({ ref: headRowRef }, { children: ths }), void 0) }, void 0) }, void 0),
            jsx_runtime_1.jsx(TBody, { children: trs }, void 0),
            pages > 1 && (jsx_runtime_1.jsx(TFoot, { children: jsx_runtime_1.jsx(Pagination, { pages: pages, activePage: activePage }, void 0) }, void 0))] }), void 0));
};
exports.Sheet = Sheet;
//# sourceMappingURL=Sheet.js.map