/// <reference types="react" />
import { Meta } from "@storybook/react";
import { SheetProps } from "./Sheet";
declare const meta: Meta;
export default meta;
export declare const Default: import("@storybook/addons").BaseStory<SheetProps, import("@storybook/react/dist/ts3.9/client/preview/types").StoryFnReactReturnType> & import("@storybook/addons").Annotations<SheetProps, import("@storybook/react/dist/ts3.9/client/preview/types").StoryFnReactReturnType> & {
    args: {
        columns: JSX.Element[];
        data: {
            key: string;
            string: string;
            number: string;
        }[];
        offset: number;
        pageSize: number;
        count: number;
    };
};
export declare const Mobile: import("@storybook/addons").BaseStory<SheetProps, import("@storybook/react/dist/ts3.9/client/preview/types").StoryFnReactReturnType> & import("@storybook/addons").Annotations<SheetProps, import("@storybook/react/dist/ts3.9/client/preview/types").StoryFnReactReturnType> & {
    args: Partial<SheetProps> & {
        columns: JSX.Element[];
        data: {
            key: string;
            string: string;
            number: string;
        }[];
        offset: number;
        pageSize: number;
        count: number;
    };
    decorators: ((Story: React.ElementType) => JSX.Element)[];
};
export declare const Active: import("@storybook/addons").BaseStory<SheetProps, import("@storybook/react/dist/ts3.9/client/preview/types").StoryFnReactReturnType> & import("@storybook/addons").Annotations<SheetProps, import("@storybook/react/dist/ts3.9/client/preview/types").StoryFnReactReturnType> & {
    args: {
        activeRow: string;
        columns: import("react").ReactElement<import("./Column").ColumnProps, import("react").FC<import("./Column").ColumnProps>>[] & JSX.Element[];
        data: import("./Sheet").Data[] & {
            key: string;
            string: string;
            number: string;
        }[];
        offset: number;
        pageSize: number;
        count: number;
        children?: import("react").ReactNode;
        Table?: import("react").ElementType<import("..").TableProps> | undefined;
        THead?: import("react").ElementType<import("..").THeadProps> | undefined;
        TBody?: import("react").ElementType<import("..").TBodyProps> | undefined;
        TFoot?: import("react").ElementType<import("..").TFootProps> | undefined;
        TR?: import("react").ElementType<import("../Theme").HasTheme & {
            primary?: boolean | undefined;
            secondary?: boolean | undefined;
            grey?: boolean | undefined;
        } & {
            transparent?: boolean | undefined;
        } & {
            children: import("react").ReactNode;
        } & {
            rowKey?: string | undefined;
        }> | undefined;
        renderTRHead?: ((props: import("..").TRHeadProps, data: import("./Sheet").Data) => import("react").ReactNode) | undefined;
        TRBody?: import("react").ElementType<import("..").TRBodyProps & {
            rowKey?: string | undefined;
        }> | undefined;
        TD?: import("react").ElementType<import("..").TDProps> | undefined;
        TH?: import("react").ElementType<import("..").THProps> | undefined;
        Pagination?: import("react").ElementType<import("..").PaginationProps> | undefined;
    };
};
export declare const WithPagination: import("@storybook/addons").BaseStory<SheetProps, import("@storybook/react/dist/ts3.9/client/preview/types").StoryFnReactReturnType> & import("@storybook/addons").Annotations<SheetProps, import("@storybook/react/dist/ts3.9/client/preview/types").StoryFnReactReturnType> & {
    args: {
        count: number;
        pageSize: number;
        offset: number;
        columns: import("react").ReactElement<import("./Column").ColumnProps, import("react").FC<import("./Column").ColumnProps>>[] & JSX.Element[];
        data: import("./Sheet").Data[] & {
            key: string;
            string: string;
            number: string;
        }[];
        activeRow?: string | undefined;
        children?: import("react").ReactNode;
        Table?: import("react").ElementType<import("..").TableProps> | undefined;
        THead?: import("react").ElementType<import("..").THeadProps> | undefined;
        TBody?: import("react").ElementType<import("..").TBodyProps> | undefined;
        TFoot?: import("react").ElementType<import("..").TFootProps> | undefined;
        TR?: import("react").ElementType<import("../Theme").HasTheme & {
            primary?: boolean | undefined;
            secondary?: boolean | undefined;
            grey?: boolean | undefined;
        } & {
            transparent?: boolean | undefined;
        } & {
            children: import("react").ReactNode;
        } & {
            rowKey?: string | undefined;
        }> | undefined;
        renderTRHead?: ((props: import("..").TRHeadProps, data: import("./Sheet").Data) => import("react").ReactNode) | undefined;
        TRBody?: import("react").ElementType<import("..").TRBodyProps & {
            rowKey?: string | undefined;
        }> | undefined;
        TD?: import("react").ElementType<import("..").TDProps> | undefined;
        TH?: import("react").ElementType<import("..").THProps> | undefined;
        Pagination?: import("react").ElementType<import("..").PaginationProps> | undefined;
    };
};
//# sourceMappingURL=Sheet.stories.d.ts.map