"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.grow = exports.isFilled = exports.isSlim = exports.bp = exports.semiTransparentBackgroundColor = exports.shade = exports.hasActivePalette = exports.palette = void 0;
var Theme_1 = require("./Theme");
var Colors_1 = require("./Colors");
var Breakpoints_1 = require("./Breakpoints");
var styled_components_1 = require("styled-components");
var polished_1 = require("polished");
var theme = function (props) { return props.theme || Theme_1.defaultTheme; };
var colors = function (props) { return theme(props).color || Colors_1.defaultColors; };
exports.palette = Object.assign(function (props) {
    var name = props.primary
        ? "primary"
        : props.secondary
            ? "secondary"
            : "grey";
    return colors(props).palette[name];
}, {
    grey: function (props) { return colors(props).palette.grey; },
    primary: function (props) { return colors(props).palette.primary; },
    secondary: function (props) { return colors(props).palette.secondary; },
});
var hasActivePalette = function (props) {
    return (props.primary === true || props.secondary === true || props.grey === true);
};
exports.hasActivePalette = hasActivePalette;
exports.shade = {
    darker: function (props) { return exports.palette(props).darker; },
    dark: function (props) { return exports.palette(props).dark; },
    medium: function (props) { return exports.palette(props).medium; },
    light: function (props) { return exports.palette(props).light; },
    lighter: function (props) { return exports.palette(props).lighter; },
    grey: {
        darker: function (props) { return exports.palette.grey(props).darker; },
        dark: function (props) { return exports.palette.grey(props).dark; },
        medium: function (props) { return exports.palette.grey(props).medium; },
        light: function (props) { return exports.palette.grey(props).light; },
        lighter: function (props) { return exports.palette.grey(props).lighter; },
    },
    primary: {
        darker: function (props) { return exports.palette.primary(props).darker; },
        dark: function (props) { return exports.palette.primary(props).dark; },
        medium: function (props) { return exports.palette.primary(props).medium; },
        light: function (props) { return exports.palette.primary(props).light; },
        lighter: function (props) { return exports.palette.primary(props).lighter; },
    },
    secondary: {
        darker: function (props) { return exports.palette.secondary(props).darker; },
        dark: function (props) { return exports.palette.secondary(props).dark; },
        medium: function (props) { return exports.palette.secondary(props).medium; },
        light: function (props) { return exports.palette.secondary(props).light; },
        lighter: function (props) { return exports.palette.secondary(props).lighter; },
    },
};
var semiTransparentBackgroundColor = function (props) {
    return polished_1.transparentize(0.9, exports.shade.dark(props));
};
exports.semiTransparentBackgroundColor = semiTransparentBackgroundColor;
var breakpoints = function (props) {
    return theme(props).breakpoints || Breakpoints_1.defaultBreakpoints;
};
exports.bp = {
    isDesktop: function (props) { return "(min-width: " + breakpoints(props).lg + "px)"; },
};
var isSlim = function (props) { return props.slim; };
exports.isSlim = isSlim;
var isFilled = function (props) { return props.filled; };
exports.isFilled = isFilled;
var grow = function (props) {
    switch (props.grow) {
        case undefined:
            return styled_components_1.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        flex-grow: 0;\n      "], ["\n        flex-grow: 0;\n      "])));
        case true:
            return styled_components_1.css(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        flex-grow: 1;\n      "], ["\n        flex-grow: 1;\n      "])));
        case false:
            return styled_components_1.css(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n        flex-grow: 0;\n      "], ["\n        flex-grow: 0;\n      "])));
        default:
            return styled_components_1.css(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n        flex-grow: ", ";\n      "], ["\n        flex-grow: ", ";\n      "])), props.grow);
    }
};
exports.grow = grow;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
//# sourceMappingURL=Selectors.js.map